%!octave 
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.1 2016/03/19 19:29:19 mechanoid Exp $

addpath("../data-proc");
addpath("../mlp");
addpath("../mlp-img");

split_long_rows(0) ; % set nowrap

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

printf("[i] загружаем данные\n"); % L учебная выборка; C - контрольная выборка ; T - тестовая выборка

[fl,fc,ft ] = data_path_img();

L=data_load_img(fl); % L={ X,Y,img_size,files_list}
%C=data_load_img(fc); % C={ X,Y,img_size,files_list}
C=L;

printf("[i] загружено %i: учебных: %i контрольных: %i \n",size(L{2},2)+size(C{2},2),size(L{2},2),size(C{2},2));

% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% % нормализация данных
% %
% printf("[i] нормализация данных  \n");
% 
% X_mean = mean(L{1},2) ; % мат.ожидание элементов элементов входного вектора
% X_std = std(L{1},[],2) ; % дисперсия элементов элементов входного вектора
% 
% save("-ascii","result/x_mean.txt","X_mean") ; 
% save("-ascii","result/x_std.txt","X_std") ; 
% 
% plot_data(X_mean,1,"data mean");  
% plot_data(X_std,2,"data std");  
% 
% % нормализация данных
% L{1}=data_norm(L{1},X_mean,X_std);
% C{1}=data_norm(C{1},X_mean,X_std);
% 
% 
% X_mean_norm = mean(L{1},2) ;
% X_std_norm = std(L{1},[],2) ;
% 
% plot_data(X_mean_norm,3,"data mean norm");  
% plot_data(X_std_norm,4,"data std norm");  
% 
% printf("[i] сохраняем результат нормализации \n"); 
% data_save_img(L{1},L{3},L{4},"norm") ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

% выход должен равняться входу
L{2}=L{1};
C{2}=C{1};

sz_in=size(L{1},1);

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% { размер слоя, тип активации }  , тип активации: input tanh expsig relu softmax
cfg = { 
   { sz_in,"input" }, 
   { 200,"relu" }, 
   { sz_in,"relu" }
 };
 
mlp_print_cfg(cfg);

save("-text","result/cfg.txt", "cfg" ) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

% обучение MLP
printf("[i] обучение ...\n"); % load("data1/w.txt");

W = mlp_weight_init(cfg) ; 

W{2}{1}=(W{1}{1})';

save("-text","result/w0.txt", "W" ) ;

%load("data1/w.txt");

trn_par={
   3e-1, % порог допустимой ошибки обучения
   200, % максимальное число эпох
   5,  % размер окна контроля за ошибкой
   5e-2, % параметр скорости обучения
   5e-3, % параметр момента 
   5e-3, % параметр регуляризации
   0.7, % доля учебных примеров в одном пакете от общего количества примеров
   10  % печатаем значение ошибки каждые print_step эпох 
};
save("-text","result/trn_par.txt", "trn_par" ) ;


[W,er]=aenc_trn_cdk(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_gd(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_cg(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_qprop(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_rprop(L,C,W,cfg,trn_par);

save("-text","result/w.txt", "W" ) ;
save("-text","result/er.txt", "er" ) ;
 
plot_error(er,0); % рисуем историю изменения ошибки обучения

weight_visualizer(W{1}{1},L{3}); % рисуем матрицу весов

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% тестируем

printf("[i] тест                   \n");
printf("[i] загружаем данные...\n");

T = data_load_img(ft) ; % T={ X,Y,img_size,files_list}
printf("[i] тестовые: %i \n", size(T{1},2) ) ;

% T{1} = data_norm(T{1},X_mean,X_std); % нормализация данных

printf("[i] выполняем ...\n"); 
R = mlp_run( T{1}, W, cfg );

%R = data_restore(R,X_mean,X_std); % восстановление нормализованных данных


printf("[i] сохраняем результат \n"); 
data_save_img(R,T{3},T{4},"out") ;

