#!/bin/sh
#
# $Id: run.sh,v 1.1 2016/03/19 19:29:19 mechanoid Exp $


trn=$(cat data_path_img.m | grep -v '%' | grep 'fl *=' | sed 's/.*= *"//;s/index.txt.*//')
ctr=$(cat data_path_img.m | grep -v '%' | grep 'fc *=' | sed 's/.*= *"//;s/index.txt.*//')
tst=$(cat data_path_img.m | grep -v '%' | grep 'ft *=' | sed 's/.*= *"//;s/index.txt.*//')

echo "учебный: $trn"
echo "тестовый: $tst"

rm -fr ./result 
# > /dev/null
mkdir -p ./result/map
mkdir -p ./result/norm
mkdir -p ./result/out

octave-cli main.m 2> ./result/err.log

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  

cd result

exec 1> ./_REPORT.html
 
echo '<!doctype html>' 
echo '<html><head><meta charset="utf-8"/></head><body>'
echo '<style> img { border: 1px solid #000; } hr { border:1px solid #000;}</style>'

#echo '<style> table {width:700px;} td:first-child { color:#f00; text-align:right; } td { text-align:center; } </style>' 

echo '<span style="color:#f00;font-weight:bold;">'
date
echo '</span>'

echo '<h1>Автоэнкодер</h1>' 

echo '<h2>учебный набор</h2>' 
for f in ../$trn/*.png; do
   echo "<img src='$f'/>" 
done
echo '<p/>' 

nr=$(ls norm/ | wc -l)
if [ $nr -gt 0 ]; then

   echo "<table style='text-align:center;'><tbody><tr>"
   echo "<td>мат.ожидание входного вектора<br/> на исходных данных</td><td>дисперсия входного вектора<br/> на исходных данных</td>"
   echo "</tr><tr>"
   echo "<td> <img src='data-1.gif'/></td> <td> <img src='data-2.gif'/></td>" 
   echo "</tr></tbody></table>"

   echo '<p/>' 

   echo "<table style='text-align:center;'><tbody><tr>"
   echo "<td>мат.ожидание входного вектора<br/>после нормализации данных</td><td>дисперсия входного вектора<br/>после нормализации данных</td>"
   echo "</tr><tr>"
   echo "<td> <img src='data-3.gif'/></td> <td> <img src='data-4.gif'/></td>" 
   echo "</tr></tbody></table>"

   echo '<p/>' 
   echo '<h2>нормализованный учебный набор</h2>' 
   for f in norm/*.png; do
	  echo "<img src='$f'/>" 
   done
   echo '<p/>' 

fi

echo '<h2>контрольный набор<h2/>'
for i in ../$ctr/*.png; do echo '<img src="'$i'"/>'  ;done
echo '<p/>' 

echo '<h2>конфигурация сети</h2>'

echo '<pre style="font-size:14pt;">'
echo 'load cfg.txt; for i=1:length(cfg), printf("%i\t%s\n",cfg{i}{1},cfg{i}{2}), endfor' | octave-cli --silent 
echo '</pre>'

echo "<p/>" 

echo '<h2>результат работы</h2>' 


fft=(`ls ../$tst/*.png`)
ffr=(`ls out/*.png`)

i_max=${#fft[*]}

i_batch=15

i0=0
i1=$( expr $i_batch - 1 )

while  [ $i0 -lt $i_max ] ; do

   if [ $i1 -ge $i_max ];then i1=$( expr $i_max - 1 ); fi

   echo '<table><tbody>'
   echo '<tr><td>вход:</td>'

   for i in `seq $i0 $i1`; do
	  echo "<td><img src='${fft[i]}'/></td>" 
   done

   echo '</tr><tr><td>выход:</td>'

   for i in `seq $i0 $i1`; do
	  echo "<td><img src='${ffr[i]}'/></td>" 
   done

   echo '</tr>'
   echo '</tbody></table><p/>'

   i0=$( expr $i1 + 1 )
   i1=$( expr $i1 + $i_batch )

done


echo "<p/>" 

echo '<h2>история изменения ошибки обучения</h2>'

echo 'метод обучения: '
cat tname.txt | grep -v '#'
echo "<p/>" 

for f in error*; do
   echo "<img src='$f'/>" 
done

echo "<p/>" 

echo '<h2>карта весов</h2>'

echo 'по количеству нейронов второго (hidden) слоя<p/>'

for f in map/*.png; do
   echo "<img src='$f'/>" 
done
 
echo '</body></html>'
 
# exec 1>&-

