%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: data_load_img.m,v 1.1 2016/03/18 09:46:16 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузка картинок
%
% lst - список файлов :  имя   класс
%
function retval=data_load_img(lst),
   img_dir = fileparts(lst); % каталог с файлами
   [f,n] = textread (lst,"%s %d"); % загружаем список файлов

   % размер изображения (предполагаем, что все изображения однотипные )
   ff=sprintf("%s/%s",img_dir,f{1}) ;
   i=imfinfo(ff) ;
   img_size=[ i.Height  i.Width ] ;

   out_size=max(n); % размер выходного вектора (количество нейронов последнего слоя)

   X=[] ; Y=[] ;
   szf=length(f);
   for i=1:szf,
	  ff=sprintf("%s/%s",img_dir,f{i}) ;
	  xi=img_load(ff);
	  X=[X xi] ;
	  yi= zeros(out_size,1); yi(n(i))=1 ; % выход сети для учебного входа номер i, {0,1}
 	  Y=[ Y  yi ] ;
	  printf("     %i / %i          \r",i,szf) ;
   endfor
   printf("\n") ;

   save("-text","result/x.txt","X");
   save("-text","result/y.txt","Y");
 
   retval={ X,Y,img_size,f};
   
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=img_load(f),
   im=imread(f) ; % загружаем изображение

   switch( class(im) )
	  case 'logical'
		 x = 1.0 - double(im) ;
	  %case 'uint8'
	  otherwise
	     x= 1.0 - lin_corr(double(im),1.0);
   endswitch
 
   if ndims(x) > 2, x = sum(x,3) / 3.0; endif

   retval = x(:) ;

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% split_long_rows(0) ; % set nowrap
% f="data/BMP/30x30-123/training/index.txt"
% cc=data_load_img2(f)
