%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.2 2016/03/20 08:48:19 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - 
split_long_rows(0) ; % set nowrap

addpath("../0-data-proc");

% - - - - - - - - - - - - - - - - 


printf("[i] загружаем данные...\n"); % L учебная выборка; C - контрольная выборка ; T - тестовая выборка

[L,C,T]=data_load_txt() ; 
printf("[i] загружено %i: учебных: %i, контрольных: %i, тестовых: %i \n",size(L{2},2)+size(C{2},2)+size(T{2},2),size(L{2},2),size(C{2},2),size(T{2},2));


sz_in=size(L{1},1);
sz_out=size(L{2},1);

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% { размер слоя, тип активации }  , тип активации: input tanh expsig exprob relu softmax

cfg = { { sz_in,"input" }, { 10,"relu" }, { sz_out,"softmax" } } ;
%cfg = { { sz_in,"input" }, { 10,"lrelu" }, { sz_out,"softmax" } } ;
%cfg = { { sz_in,"input" }, { 25,"tanh" }, { sz_out,"expsig" } } ;

mlp_print_cfg(cfg);

save("-text","result/cfg.txt", "cfg" ) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% обучение MLP
printf("[i] обучение ...\n");

W=mlp_weight_init(cfg) ; 
save("-text","result/w0.txt", "W" ) ;

trn_par={
   3e-2, % порог допустимой ошибки обучения
   2000, % максимальное число эпох
   5,  % размер окна контроля за ошибкой
   5e-2, % параметр скорости обучения
   5e-3, % параметр момента 
   1e-4, % параметр регуляризации
   0.7, % доля учебных примеров в одном пакете от общего количества примеров
   20  % печатаем значение ошибки каждые print_step эпох 
};
save("-text","result/trn_par.txt", "trn_par" ) ;


[W,er]=mlp_trn_gd(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_cg(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_qprop(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_rprop(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_bfgs(L,C,W,cfg,trn_par);
%[W,er]=mlp_trn_lm(L,C,W,cfg,trn_par); % no relu

save("-text","result/w.txt","W") ;
save("-text","result/er.txt","er") ;
 
plot_error(er,0); % рисуем историю изменения ошибки обучения


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
printf("[i] тест                       \n");

[ er,o ] = mlp_loss(T,W,cfg,0.0) ;
save("-text","result/o.txt", "o" ) ;


% рисуем результат
plot_txt({T{1},o},"xt-res",er) ;

