%!octave 
%
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_activate.m,v 1.2 2016/03/20 08:48:19 mechanoid Exp mechanoid $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% функция активации 
function retval=mlp_activate(x,ta),
   switch(ta)
	  case "tanh"
		 b=1.0; retval=tanh(b*x);

	  %case "trd" % threshold
	  % b=0.0; retval=(x>b);

      case "exprob"
		 b=1.0; a=1.0; 
		 p = b./(1.0+exp(-x.*a));
		 retval = ( rand(size(p)) < p ) ;


	  case "expsig"
		 b=2.0; a=10.0; retval=b./(1.0+exp(-x.*a));

	  case "lrelu"
		 %a=0.09; retval=max(x*a,x); % Leaky ReLU
		 retval=log(1.0+exp(x));

	  case "relu"
		 retval=max(0,x); 

	  case "softmax"
		 ex=exp(x);
		 retval=ex./sum(ex);
	 
	  case "input"
	  	 retval=x;

	  otherwise 
		 printf("\n[e] не изестная функция активации %s\n",ta);
		 exit -1;
   endswitch

endfunction

