%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_loss.m,v 1.1 2016/03/19 19:02:54 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% функция ошибки (потери) сети
function [ loss o ] = mlp_loss(C,W,cfg,rpar),
   ltp=2; % номер ячейки cfg с типом ф-ции активации

   o=mlp_run(C{1},W,cfg) ; % вычисляем выходы сети на контрольном наборе

   switch( cfg{end}{ltp} ),

	  case "softmax" % для выхода softmax используем среднюю крос-энтропию
		loss = cross_entr(o,C{2});

	  otherwise % case "tanh" case "expsig" case "relu"
		loss =msqe(o,C{2}); % для остальных типов выхода используем среднюю квадратическую ошибку

   endswitch

   % поправка регуляризации
   reg_loss=0.0; for i=1:length(cfg)-1, reg_loss += sum(sum(W{i}{1}.^2)); endfor

   loss +=reg_loss*0.5*rpar;

endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% функция потери - средняя кросс-энтропия
function retval = cross_entr(o,y),
   [v n]=max(y); % извлекаем номер класса из выходного вектора
   num_examples=length(n); % количество учебных примеров

   % вероятность p(i) принадлежности входа X(i) к к своему классу n(i) 
   p=[];
   for i=1:num_examples, 
	  p(i)=o(n(i),i); 
   endfor
   
   data_loss = sum(-log(p))/num_examples; % средняя крос-энтропия по всем учебным примерам
   
   retval= data_loss;
endfunction

% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% % функция потери - средняя квадратическая ошибка
% function retval=msqe(c,r),
%    er=(c-r)(:);
%    retval=(er'*er)/size(r,2);
% 
%    %retval=sum( sum((c-r).^2) )/size(r,2);
% endfunction

