%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: data_save_img.m,v 1.1 2016/02/08 17:22:24 mechanoid Exp mechanoid $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function data_save_img(D,pref),
   X=D{1}; Y=D{2};
   ex_numb=size(X,4);

   indx={};
   printf("[i] сохраняем результат... \n");
   for i=1:ex_numb,
	  xi=X(:,:,:,i) ;
      yi=find(Y(i,:)>0)-1;
      fn=sprintf("%04i-N%i.png",i,yi);
      f=sprintf("result/%s%s",pref,fn);
	  img_save( xi, f ) ;
	  indx{i}={fn,yi+1};
      printf("    %i / %i     \r",i,ex_numb);
   endfor
   printf("\n");

   save_index(indx,sprintf("result/%sindex.txt",pref));

endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function save_index(indx,f),
   fid = fopen (f, "w");
   ex_numb=length(indx);
   for i=1:ex_numb,
	  fprintf(fid,"%s \t%i\n",indx{i}{1},indx{i}{2});
      printf("    %i / %i     \r",i,ex_numb);
   endfor
   printf("\n");
   fclose (fid);
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function img_save(x,f),
   x=img_lin_cor(x);
   x= uint8(255.0 - x);
   imwrite(x,f) ;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=img_lin_cor(x),
   xl=x(:);
   mn=min(xl); mx=max(xl);
   x= 255.0*(x-mn)/(mx-mn) ;
   retval=x;
endfunction


