%!octave 
%
%      
%       OS : GNU/Linux 3.18.4-1-ARCH 
% COMPILER : GNU Octave, version 3.8.2
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: load_MNIST_lables.m,v 1.1 2016/01/28 12:32:09 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% загрузка меток образов из набора данных MNIST
% f - имя файла БД
%
function retval = load_MNIST_lables(f),
   [ fid emsg ] = fopen(f,"r","ieee-be") ; % открываем файл БД на чтение
   if(fid<0) printf("[E] open: '%s' %s\n",f,emsg) ; exit -1; endif
   printf("[i] БД: %s\n",f);
 
   mnum = fread(fid,1,"int32") ; % проверяем magic number файла БД
   if(mnum~=2049) printf("[E] bad magic number") ; fclose(fid); exit -1; endif

   s = fread(fid,1,"int32") ; % количество образов в БД

   labels = uint8(fread(fid,s,"uint8")) ; % загружаем метки
 
   fclose(fid);

   retval=labels;

endfunction 

