%!octave 
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_pretrain.m,v 1.2 2016/03/20 08:16:29 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = mlp_pretrain(L,W,cfg,trn_par),
   ltp=2; % номер ячейки конфига сети с типом слоя
   %max_iter=900; % максимальное число циклов обучения
   %min_err=2e-1; % допустимая ошибка

   printf("[i] предобучение ...\n"); % load("data1/w.txt");

   layers_numb=length(cfg) ; % количество слоёв

   if strcmp( cfg{end}{ltp} , "softmax" ),  % последний softmax слой не предобучаем
	  layers_numb -= 1; 
   endif

   % набор данных для предобучения входного слоя
   Li = L; Li{2} = Li{1}; 

   for i=1:layers_numb-1, % для всех пар соседних слоёв
	  printf("[i] обучение AENC %i  \n",i); 

	  acfg = make_config(cfg,i); % определить конфигурацию автоэнкодера (размеры и тип слоёв)

	  Wi = weight_init(W,i); % инициализировать веса

	  % обучаем
	  [Wi,er]=aenc_trn_cdk(Li,Li,Wi,acfg,trn_par);
	  %[Wi,er]=mlp_trn_gd(Li,Li,Wi,acfg,trn_par);
	  %[Wi,er]=mlp_trn_cg(Li,Li,Wi,acfg,trn_par);
	  %[Wi,er]=mlp_trn_qprop(Li,Li,Wi,acfg,trn_par);
	  %[Wi,er]=mlp_trn_rprop(Li,Li,Wi,acfg,trn_par);

	  plot_error(er,i); % рисуем историю изменения ошибки обучения

	  W{i} = Wi{1}; % сохраняем веса

	  Li = make_dataset(Li,Wi,acfg); % генерировать набор данных cледующего слоя

   endfor

   retval = W;

endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = make_config(cfg,i),
   ltp=2; % номер ячейки конфига сети с типом слоя

   acfg={};
   acfg{1}=cfg{i} ;  
   acfg{2}=cfg{i+1} ;  
   acfg{3}=cfg{i} ;  
   acfg{3}{ltp}=cfg{i+1}{ltp} ;  

   retval=acfg;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = weight_init(W,i),
   Wi={};
   Wi{1} = W{i}; 
   Wi{2}{1} = (Wi{1}{1})';
   Wi{2}{2} = zeros(size(Wi{2}{1},1),1);
   retval=Wi;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% генерировать набор данных cледующего слоя
function retval = make_dataset(L,W,cfg),
	  W(2)=[]; 
	  cfg(3)=[];

	  R = mlp_run(L{1},W,cfg) ; 
	  D={};
	  D{1}=D{2}=R;
	  retval=D;
endfunction


% предобучение:
%    определить размеры слоёв
%    повторить для всех соседних пар слоёв  
% 	  обучить AENC
% 	  сохранить веса
% 	  генерировать следующий набор данных (выходы скрытого слоя)
% 
% собрать mlp из получившихся матриц весов 
% обучить mlp
% 
% тестировать mlp


