#!/bin/sh

#trn="data/images/numb/30x30/training"; 
#tst="data/images/numb/30x30/test3"; 

trn=$(cat data_path_img.m | grep -v '%' | grep 'fl *=' | sed 's/.*= *"//;s/index.txt.*//')
ctr=$(cat data_path_img.m | grep -v '%' | grep 'fc *=' | sed 's/.*= *"//;s/index.txt.*//')
tst=$(cat data_path_img.m | grep -v '%' | grep 'ft *=' | sed 's/.*= *"//;s/index.txt.*//')

echo $trn
echo $ctr
echo $tst


rm -fr ./result
mkdir -p result/map

octave-cli main.m 2> result/err.log

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

cd result

exec 1>_REPORT.html


echo '<html><header><meta charset="utf-8"/></header><body><style>body {color: #000;} img {border: 1px solid #000;} </style>' 

echo '<p/>'
date
echo '<p/>&nbsp<p/>'

echo '<h2>учебный набор<h2/>'
for i in ../$trn/*.png; do echo '<img src="'$i'"/>'  ;done
echo '<p/>' 

echo '<h2>контрольный набор<h2/>'
for i in ../$ctr/*.png; do echo '<img src="'$i'"/>'  ;done

echo '<h2>конфигурация сети</h2>'

echo '<pre style="font-size:14pt;">'
echo 'load cfg.txt; for i=1:length(cfg), printf("%i\t%s\n",cfg{i}{1},cfg{i}{2}), endfor' | octave-cli --silent 
echo '</pre>'

echo '<h2>результаты теста</h2>'

nn=(`cat answ-n.txt | sed '/^#/d' | sed '/^  *$/d'`)
pp=(`cat answ-p.txt | sed '/^#/d' | sed '/^  *$/d'`)
ee=(`cat answ-e.txt | sed '/^#/d' | sed '/^  *$/d'`)
ev=(`cat answ-ev.txt | sed '/^#/d' | sed '/^  *$/d'`)

echo  "примеров: ${ee[1]} <br/>ошибок: ${ee[0]}<p/>"

fft=(`ls ../$tst/*.png`)
i_max=${#fft[*]}

i_batch=20

i0=0
i1=$( expr $i_batch - 1 )




echo '<style>
    .res table { border-collapse: collapse; width: 100%; border-spacing: 0; }
    .res td { border: 1px solid #6A3E14; padding: 4px; text-align:center; }
    .res tr:first-of-type { background: #808990; }
    .res td:first-of-type { background: #CFD6D3; }
   </style>'

while  [ $i0 -lt $i_max ] ; do

   if [ $i1 -ge $i_max ];then i1=$( expr $i_max - 1 ); fi

   echo '<table class="res"><tbody>'
   echo '<tr><td>вход:</td>'

   for i in `seq $i0 $i1`; do
	  echo '<td><img src="'${fft[i]}'"/></td>' 
   done

   echo '</tr><tr><td>класс:</td>'

   for i in `seq $i0 $i1`; do
      if [ ${ev[i]} -gt 0 ]; then
	  		cl='#f00'
	  else
	  		cl='#0f0'
	  fi
	  echo "<td style='background:$cl;'>"${nn[i]}'</td>' 
   done

   echo '</tr><tr><td>выход:</td>'

   for i in `seq $i0 $i1`; do
	  pi=`echo ${pp[i]} | sed 's/\./,/'` ; 
	  echo '<td>'
	  printf "%.2f" $pi; 
	  echo '</td>'

   done

   echo '</tr>'
   echo '</tbody></table><p/>'

   i0=$( expr $i1 + 1 )
   i1=$( expr $i1 + $i_batch )

done



 
echo '<p/>&nbsp<p/>'

echo '<h2>история изменения ошибки обучения</h2>' 

echo 'метод обучения: '
cat tname.txt | grep -v '#' 

echo '<p/>'

ffe=(`ls error*.gif`)
i_max=${#ffe[*]}
i_max=$( expr $i_max - 1 )

echo '<h3>история изменения ошибки предобучения слоёв</h3>' 

k=1
for i in `seq 2 2 $i_max`; do 
   j=$( expr $i + 1 )
   echo "<br/>слой $k:<br/>"
   echo '<img src="'${ffe[i]}'"/> <img src="'${ffe[j]}'"/><br/>'  
   k=$( expr $k + 1 )
done

echo '<h3>история изменения ошибки обучения сети</h3>' 
echo '<img src="'${ffe[0]}'"/> <img src="'${ffe[1]}'"/> <p/>'  

echo '<p/>' 

echo '<h2>карта весов первого слоя</h2>' 

echo 'по количеству нейронов первого обрабатывающего слоя<p/>'

for i in map/vis*.png; do echo '<img src="'$i'"/>'  ;done
echo '</body></html>' 

cd ..

# exec 1>&-

# $Id: run.sh,v 1.1 2016/03/19 19:57:50 mechanoid Exp $
